/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.51 by adcroft, Wed Dec 3 19:46:10 2003 UTC revision 1.79 by edhill, Wed Jun 16 21:15:47 2004 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -e Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -e Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161  # Guess possible config options for this host  # Guess possible config options for this host
162  find_possible_configs()  {  find_possible_configs()  {
163    
164      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
165      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
166      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
167      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
168        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
169        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
170        PLATFORM=$tmp3
171        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
172      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
173      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
174            
# Line 93  find_possible_configs()  { Line 188  find_possible_configs()  {
188          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
189      fi      fi
190    
191      # makedepend is not always available      #  The "original" makedepend is part of the Imake system that is
192        #  most often distributed with XFree86 or with an XFree86 source
193        #  package.  As a result, many machines (eg. generic Linux) do not
194        #  have a system-default "makedepend" available.  For those
195        #  systems, we have two fall-back options:
196        #
197        #    1) a makedepend implementation shipped with the cyrus-imapd
198        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
199        #
200        #    2) a known-buggy xmakedpend shell script
201        #
202        #  So the choices are, in order:
203        #
204        #    1) use the user-specified program
205        #    2) use a system-wide default
206        #    3) locally build and use the cyrus implementation
207        #    4) fall back to the buggy local xmakedpend script
208        #
209      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
210        which makedepend >& /dev/null        which makedepend > /dev/null 2>&1
211        RETVAL=$?        RV0=$?
212        if test "x${RETVAL}" = x1 ; then        cat <<EOF >> genmake_tc.f
213           echo "    makedepend was not found. Using xmakedpend instead."        program test
214           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'        write(*,*) 'test'
215          stop
216          end
217    EOF
218          makedepend genmake_tc.f > /dev/null 2>&1
219          RV1=$?
220          if test ! "x${RV0}${RV1}" = x00 ; then
221             echo "    a system-default makedepend was not found."
222    
223             #  Try to build the cyrus impl
224             rm -f ./genmake_cy_md
225             (
226                 cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
227                     &&  ./configure > /dev/null 2>&1  \
228                     &&  make > /dev/null 2>&1
229                 if test -x ./makedepend.exe ; then
230                     $LN ./makedepend.exe ./makedepend
231                 fi
232                 ./makedepend ifparser.c > /dev/null 2>&1  \
233                     &&  echo "true"
234             ) > ./genmake_cy_md
235             grep true ./genmake_cy_md > /dev/null 2>&1
236             RETVAL=$?
237             if test "x$RETVAL" = x0 ; then
238                 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
239             else
240                 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
241             fi
242             rm -f ./genmake_cy_md
243        fi        fi
244      fi      fi
245    
# Line 138  EOF Line 278  EOF
278          echo "   "$p_FC          echo "   "$p_FC
279          if test "x$FC" = x ; then          if test "x$FC" = x ; then
280              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
281                echo "  Setting FORTRAN compiler to: "$FC
282          fi          fi
283      fi      fi
284    
285      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
286          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
287          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
288              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
289              echo "  The options file:  $p_OF"          fi
290              echo "    appears to match so we'll use it."      fi
291              break  #    echo "  The options file:  $p_OF"
292          fi  #    echo "    appears to match so we'll use it."
293      done  #   for i in $p_FC ; do
294    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
295    #if test -r $p_OF ; then
296    #    OPTFILE=$p_OF
297    #    echo "  The options file:  $p_OF"
298    #    echo "    appears to match so we'll use it."
299    #    break
300    #fi
301    #   done
302      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
303          cat 1>&2 <<EOF          cat 1>&2 <<EOF
304    
# Line 208  get_pdepend_list()  { Line 357  get_pdepend_list()  {
357      . ./.pd_tmp      . ./.pd_tmp
358      rm -f ./.pd_tmp      rm -f ./.pd_tmp
359    
360      echo -n "PNAME = "${}      printf "PNAME = "${}
361  }  }
362    
363    
# Line 222  Usage: "$0" [OPTIONS] Line 371  Usage: "$0" [OPTIONS]
371      -help | --help | -h | --h      -help | --help | -h | --h
372            Print this help message and exit.            Print this help message and exit.
373    
374        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
375          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
376              Use "NAME" as the adoptfile.  By default, the file at
377              "tools/adjoint_options/adjoint_default" will be used.
378    
379      -nooptfile | --nooptfile      -nooptfile | --nooptfile
380        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
381        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 246  Usage: "$0" [OPTIONS] Line 400  Usage: "$0" [OPTIONS]
400        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
401            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
402    
403        -makedepend NAME | -md NAME
404          --makedepend=NAME | -md=NAME
405              Use "NAME" for the MAKEDEPEND program.
406    
407      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
408        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
409            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 287  Usage: "$0" [OPTIONS] Line 445  Usage: "$0" [OPTIONS]
445            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
446            is being used.            is being used.
447    
448        -mpi | --mpi
449              Include MPI header files and link to MPI libraries
450        -mpi=PATH | --mpi=PATH
451              Include MPI header files and link to MPI libraries using MPI_ROOT
452              set to PATH. i.e. Include files from $PATH/include, link to libraries
453              from $PATH/lib and use binaries from $PATH/bin.
454    
455        -bash NAME
456              Explicitly specify the Bourne or BASH shell to use
457    
458    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
459    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
460    
# Line 430  EOF Line 598  EOF
598  }  }
599    
600    
601    check_netcdf_libs()  {
602        cat <<EOF > genmake_tnc.for
603          program fgennc
604    #include "netcdf.inc"
605          integer iret, ncid, xid
606          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
607          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
608          iret = nf_def_dim(ncid, 'X', 11, xid)
609          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
610          iret = nf_close(ncid)
611          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
612          end
613    EOF
614        $CPP genmake_tnc.for > genmake_tnc.f  \
615            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
616        RET_COMPILE=$?
617        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
618        RETVAL=$?
619        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
620            HAVE_NETCDF=t
621        else
622            # try again with "-lnetcdf" added to the libs
623            $CPP genmake_tnc.for > genmake_tnc.f  \
624                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
625                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
626            RET_COMPILE=$?
627            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
628            RETVAL=$?
629            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
630                LIBS="$LIBS -lnetcdf"
631                HAVE_NETCDF=t
632            else
633                cat genmake_tnc.log >> genmake_warnings
634            fi
635        fi
636        rm -f genmake_tnc*
637    }
638    
639    
640    
641    ###############################################################################
642    #   Sequential part of script starts here
643    ###############################################################################
644    
645  #  Set defaults here  #  Set defaults here
646  COMMANDL="$0 $@"  COMMANDL="$0 $@"
647    
# Line 438  LN= Line 650  LN=
650  S64=  S64=
651  KPP=  KPP=
652  FC=  FC=
653    CPP=
654  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
655  DEFINES=  DEFINES=
656  PACKAGES=  PACKAGES=
657  ENABLE=  ENABLE=
# Line 456  FOPTIM= Line 668  FOPTIM=
668  CFLAGS=  CFLAGS=
669  KFLAGS1=  KFLAGS1=
670  KFLAGS2=  KFLAGS2=
671    #LDADD=
672  LIBS=  LIBS=
673  KPPFILES=  KPPFILES=
674  NOOPTFILES=  NOOPTFILES=
675  NOOPTFLAGS=  NOOPTFLAGS=
676    MPI=
677    MPIPATH=
678    
679  # DEFINES checked by test compilation  # DEFINES checked by test compilation
680  HAVE_SYSTEM=  HAVE_SYSTEM=
681  HAVE_FDATE=  HAVE_FDATE=
682  FC_NAMEMANGLE=  FC_NAMEMANGLE=
683  HAVE_CLOC=  HAVE_CLOC=
684    HAVE_NETCDF=
685    
686  MODS=  MODS=
687  TOOLSDIR=  TOOLSDIR=
688  SOURCEDIRS=  SOURCEDIRS=
689  INCLUDEDIRS=  INCLUDEDIRS=
690  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
691    
692    G2ARGS=
693    BASH=
694  PWD=`pwd`  PWD=`pwd`
695  MAKE=make  MAKE=make
696  AWK=awk  AWK=awk
# Line 488  IEEE= Line 706  IEEE=
706  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
707      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
708  fi  fi
709    FS=
710    FS90=
711    
712  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
713  AD_OPTFILE=  AD_OPTFILE=
# Line 505  TAMC_EXTRA= Line 725  TAMC_EXTRA=
725    
726  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
727  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
728  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
729    
730  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
731  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 541  for i in . $MODS ; do Line 761  for i in . $MODS ; do
761          break          break
762      fi      fi
763  done  done
764  echo -n "  getting local config information:  "  printf "  getting local config information:  "
765  if test -e $gm_local ; then  if test -e $gm_local ; then
766      echo "using $gm_local"      echo "using $gm_local"
767      . $gm_local      . $gm_local
# Line 565  fi Line 785  fi
785  ac_prev=  ac_prev=
786  for ac_option ; do  for ac_option ; do
787    
788        G2ARGS="$G2ARGS \"$ac_option\""
789    
790      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
791      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
792          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 606  for ac_option ; do Line 828  for ac_option ; do
828          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
829              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
830                    
831            -bash | --bash)
832                ac_prev=BASH ;;
833            -bash=* | --bash=*)
834                BASH=$ac_optarg ;;
835            
836            -makedepend | --makedepend | -md | --md)
837                ac_prev=MAKEDEPEND ;;
838            -makedepend=* | --makedepend=* | -md=* | --md=*)
839                MAKEDEPEND=$ac_optarg ;;
840            
841          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
842              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
843          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 653  for ac_option ; do Line 885  for ac_option ; do
885          -fc=* | --fc=*)          -fc=* | --fc=*)
886              FC=$ac_optarg ;;              FC=$ac_optarg ;;
887                    
888            -fs | --fs)
889                ac_prev=FS ;;
890            -fs=* | --fs=*)
891                FS=$ac_optarg ;;
892            
893            -fs90 | --fs90)
894                ac_prev=FS90 ;;
895            -fs90=* | --fs90=*)
896                FS90=$ac_optarg ;;
897            
898          -ieee | --ieee)          -ieee | --ieee)
899              IEEE=true ;;              IEEE=true ;;
900          -noieee | --noieee)          -noieee | --noieee)
901              IEEE= ;;              IEEE= ;;
902    
903            -mpi | --mpi)
904                MPI=true ;;
905            -mpi=* | --mpi=*)
906                MPIPATH=$ac_optarg
907                MPI=true ;;
908                    
909  #       -jam | --jam)  #       -jam | --jam)
910  #           JAM=1 ;;  #           JAM=1 ;;
# Line 709  if test "x${ROOTDIR}" = x ; then Line 957  if test "x${ROOTDIR}" = x ; then
957          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
958              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
959                  ROOTDIR=$d                  ROOTDIR=$d
960                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
961                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
962                  break                  break
963              fi              fi
# Line 743  if test "x$OPTFILE" != xNONE ; then Line 991  if test "x$OPTFILE" != xNONE ; then
991          . "$OPTFILE"          . "$OPTFILE"
992          RETVAL=$?          RETVAL=$?
993          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
994              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
995              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
996              exit 1              exit 1
997          fi          fi
# Line 756  if test "x$OPTFILE" != xNONE ; then Line 1004  if test "x$OPTFILE" != xNONE ; then
1004      fi      fi
1005  fi  fi
1006    
1007    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1008    # check_for_broken_Ff
1009    
1010  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1011  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1012      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 770  if test "x${AD_OPTFILE}" != xNONE ; then Line 1021  if test "x${AD_OPTFILE}" != xNONE ; then
1021          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1022          RETVAL=$?          RETVAL=$?
1023          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1024              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1025              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1026              exit 1              exit 1
1027          fi          fi
# Line 785  fi Line 1036  fi
1036    
1037  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1038  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1039    if test ! "x$BASH" = x ; then
1040        # add a trailing space so that it works within the Makefile syntax (see below)
1041        BASH="$BASH "
1042    fi
1043  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1044      cat <<EOF 1>&2      cat <<EOF 1>&2
1045    
# Line 798  fi Line 1053  fi
1053  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1054      LINK=$FC      LINK=$FC
1055  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
1056  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1057      MAKE="make"      MAKE="make"
1058  fi  fi
1059    if test "x$CPP" = x ; then
1060        CPP=cpp
1061    fi
1062    #EH3 === UGLY ===
1063    #  The following is an ugly little hack to check for $CPP in /lib/ and
1064    #  it should eventually be replaced with a more general function that
1065    #  searches a combo of the user's path and a list of "usual suspects"
1066    #  to find the correct location for binaries such as $CPP.
1067    for i in " " "/lib/" ; do
1068        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1069    done
1070    #EH3 === UGLY ===
1071  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1072  RETVAL=$?  RETVAL=$?
1073  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 840  EOF Line 1104  EOF
1104  fi  fi
1105  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1106    
1107    #  Check for broken *.F/*.f handling and fix if possible
1108    check_for_broken_Ff
1109    
1110    if test ! "x$MPI" = x ; then
1111          echo "  Turning on MPI cpp macros"
1112          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1113    fi
1114    
1115  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1116  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1117  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1118        program hello        program hello
1119        call system('echo hi')        call system('echo hi')
# Line 860  else Line 1131  else
1131  fi  fi
1132  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1133    
1134  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1135  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1136        program hello        program hello
1137        CHARACTER(128) string        CHARACTER(128) string
# Line 881  else Line 1152  else
1152  fi  fi
1153  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1154    
1155  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1156  check_HAVE_CLOC  check_HAVE_CLOC
1157  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1158      echo "yes"      echo "yes"
1159  else  else
1160      echo "no"      echo "no"
1161  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
1162  rm -f genmake_t*  rm -f genmake_t*
1163    
1164    printf "  Can we create NetCDF-enabled binaries...  "
1165    check_netcdf_libs
1166    if test "x$HAVE_NETCDF" != x ; then
1167        echo "yes"
1168    else
1169        echo "no"
1170    fi
1171    
1172    
1173  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1174  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1175  for d in $MODS ; do  for d in $MODS ; do
1176      if test ! -d $d ; then      if test ! -d $d ; then
1177          echo          echo
1178          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1179          exit 1          exit 1
1180      else      else
1181          echo -n " $d"          printf " $d"
1182          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1183          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1184      fi      fi
# Line 935  if test "x${TOOLSDIR}" = x ; then Line 1208  if test "x${TOOLSDIR}" = x ; then
1208      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1209  fi  fi
1210  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1211      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1212      exit 1      exit 1
1213  fi  fi
1214  if test "x$S64" = x ; then  if test "x$S64" = x ; then
# Line 956  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1229  if test -r $ROOTDIR"/eesupp/src/Makefile
1229          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1230      else      else
1231          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1232          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1233          exit 1          exit 1
1234      fi      fi
1235  fi  fi
1236    
1237    #same for exch2
1238    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1239        echo "  Making source files in exch2 from  templates"
1240        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1241        RETVAL=$?
1242        if test "x${RETVAL}" = x0 ; then
1243            rm -f make_exch2.errors
1244        else
1245            echo "Error: problem encountered while building source files in exch2:"
1246            cat make_exch2.errors 1>&2
1247            exit 1
1248        fi
1249    fi
1250    
1251  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1252  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1253      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1016  else Line 1303  else
1303          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1304          RETVAL=$?          RETVAL=$?
1305          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1306              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1307              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1308              exit 1              exit 1
1309          fi          fi
# Line 1024  else Line 1311  else
1311              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1312          done          done
1313          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1314          expand_pkg_groups          while ! expand_pkg_groups; do echo > /dev/null; done
1315          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1316      fi      fi
1317  fi  fi
1318    
1319  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1320    for i in $PACKAGES ; do
1321        echo $i >> ./.tmp_pack
1322    done
1323    for i in `grep  "-" ./.tmp_pack` ; do
1324        j=`echo $i | sed 's/[-]//'`
1325        DISABLE="$DISABLE $j"
1326    done
1327  pack=  pack=
1328  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1329      addit="t"      addit="t"
# Line 1046  PACKAGES="$pack" Line 1340  PACKAGES="$pack"
1340  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1341  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1342  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1343    # Test if each explicitly referenced package exists
1344  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1345      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1346        if test ! -d "$ROOTDIR/pkg/$j" ; then
1347          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1348          exit 1          exit 1
1349      fi      fi
1350      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1351  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1352  PACKAGES=  PACKAGES=
1353  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1354      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1355  done  done
1356    rm -f ./.tmp_pack
1357  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1358    
1359  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1144  for i in $PACKAGES ; do Line 1439  for i in $PACKAGES ; do
1439      fi      fi
1440  done  done
1441    
1442    #  Build MNC templates and check for ability to build and use NetCDF
1443    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1444    RETVAL=$?
1445    if test "x$RETVAL" = x0 ; then
1446        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1447        RETVAL=$?
1448        if test "x${RETVAL}" = x0 ; then
1449            rm -f make_mnc.errors
1450        else
1451            echo "Error: problem encountered while building source files in pkg/mnc:"
1452            cat make_mnc.errors 1>&2
1453            exit 1
1454        fi
1455        if test "x$HAVE_NETCDF" != xt ; then
1456            cat <<EOF
1457    
1458    WARNING: the "mnc" package has been enabled but tests failed to
1459      compile and/or execute NetCDF applications.  Please check that:
1460    
1461      1) NetCDF is installed for your compiler and
1462      2) the LIBS variable (within the 'optfile") specifies the correct
1463           NetCDF library to link against.
1464      
1465    EOF
1466        fi
1467    fi
1468    
1469  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1470  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
# Line 1178  for i in $PACKAGES ; do Line 1499  for i in $PACKAGES ; do
1499  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1500      case $i in      case $i in
1501          aim_v23)          aim_v23)
             DEFINES="$DEFINES -DALLOW_AIM"  
1502              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1503              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
1504              ;;              ;;
1505      esac      esac
1506  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
# Line 1189  done Line 1509  done
1509    
1510  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1511  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1512  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1513      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1514  fi  fi
1515  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1516      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1517      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1518          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1519          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1520          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1521      else              exit 1
1522          SOURCEDIRS="$SOURCEDIRS $adr"          else
1523      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1524      adr="$ROOTDIR/$d/inc"          fi
1525      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1526          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1527          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1528          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1529      else              exit 1
1530          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1531      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1532  done          fi
1533        done
1534    fi
1535    
1536  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1537  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1538  CPP_OPTIONS=  CPP_OPTIONS=
1539    CPP_EEOPTIONS=
1540  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1541    names=`ls -1 "$ROOTDIR/pkg"`
1542  for i in $spaths ; do  for i in $spaths ; do
1543      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1544      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1545          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1546          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1547          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1548            for n in $names ; do
1549                test_for_package_in_cpp_options $CPP_OPTIONS $n
1550            done
1551        fi
1552        try="$i/CPP_EEOPTIONS.h"
1553        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1554            echo "    found CPP_EEOPTIONS=\"$try\""
1555            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1556    #**** not yet enabled ****
1557    #        test_for_mpi_in_cpp_eeoptions $try
1558    #**** not yet enabled ****
1559            CPP_EEOPTIONS="$try"
1560      fi      fi
1561  done  done
1562  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1563      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1564      exit 1      exit 1
1565  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1566    
1567  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1568  #  compiler.  #  compiler.
# Line 1248  for i in $SOURCEDIRS ; do Line 1577  for i in $SOURCEDIRS ; do
1577      done      done
1578  done  done
1579    
1580    
1581  echo  echo
1582  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1583  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 1264  rm -rf .links.tmp Line 1594  rm -rf .links.tmp
1594  mkdir .links.tmp  mkdir .links.tmp
1595  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1596  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1597  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1598  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1599  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1600  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1601  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1602  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1603  for d in $alldirs ; do  for d in $alldirs ; do
1604      deplist=      deplist=
# Line 1293  for d in $alldirs ; do Line 1623  for d in $alldirs ; do
1623                  case $extn in                  case $extn in
1624                      F)                      F)
1625                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1626                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1627                          ;;                          ;;
1628                      F90)                      F90)
1629                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1630                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1631                          ;;                          ;;
1632                      c)                      c)
1633                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1634                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1635                          ;;                          ;;
1636                      h)                      h)
1637                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1638                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1639                          ;;                          ;;
1640                      flow)                      flow)
1641                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1642                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1643                          ;;                          ;;
1644                  esac                  esac
1645              fi              fi
# Line 1338  echo "#    $MACHINE" >> $MAKEFILE Line 1668  echo "#    $MACHINE" >> $MAKEFILE
1668  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1669  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1670  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1671  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1672  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1673  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1674    
# Line 1347  EXE_FTL=$EXECUTABLE"_ftl" Line 1677  EXE_FTL=$EXECUTABLE"_ftl"
1677  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1678    
1679  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1680    #
1681    # OPTFILE="$OPTFILE"
1682  #  #
1683  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1684  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1383  EXE_SVD     = ${EXE_SVD} Line 1715  EXE_SVD     = ${EXE_SVD}
1715  ENABLED_PACKAGES = ${ENABLED_PACKAGES}  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1716  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1717    
1718    # These files are created by Makefile
1719    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1720    
1721  EOF  EOF
1722    
1723  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1401  FC = ${FC} Line 1736  FC = ${FC}
1736  # Fortran compiler  # Fortran compiler
1737  F90C = ${F90C}  F90C = ${F90C}
1738  # Link editor  # Link editor
1739  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1740    
1741  # Defines for CPP  # Defines for CPP
1742  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1433  cat csrclist.inc      >> $MAKEFILE Line 1768  cat csrclist.inc      >> $MAKEFILE
1768  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1769  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1770  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1771  echo               >> $MAKEFILE  echo >> $MAKEFILE
1772  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1773  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1774  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1775    echo >> $MAKEFILE
1776    echo '.SUFFIXES:' >> $MAKEFILE
1777    echo '.SUFFIXES: .o .F .p .'$FS' .c .F90 .'$FS90 >> $MAKEFILE
1778  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1779  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1780    
1781  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1782    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1783  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1784  \$(EXECUTABLE): ${PACKAGES_DOT_H} AD_CONFIG.h \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1785          @echo Creating \$@ ...          @echo Creating \$@ ...
1786          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1787  depend:  depend:
1788          @make links          @make links
1789          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1790          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1791            -rm -f makedepend.out
1792    
1793  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) ${PACKAGES_DOT_H} AD_CONFIG.h  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1794    
1795  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1796    
# Line 1464  output.txt: \$(EXECUTABLE) Line 1799  output.txt: \$(EXECUTABLE)
1799          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1800    
1801  clean:  clean:
1802          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1803  Clean:  Clean:
1804          @make clean          @make clean
1805          @make cleanlinks          @make cleanlinks
1806          -rm -f ${PACKAGES_DOT_H} AD_CONFIG.h          -rm -f \$(SPECIAL_FILES)
1807          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1808  CLEAN:  CLEAN:
1809          @make Clean          @make Clean
1810          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1811          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1812          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1813          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1814    
1815  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1816  makefile:  makefile:
1817          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1818  cleanlinks:  cleanlinks:
1819          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1820    
1821  # Special targets  # Special targets ($SPECIAL_FILES) which are create by make
1822  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1823          @echo Creating \$@ ...          @echo Creating \$@ ...
1824          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1825  AD_CONFIG.h:  AD_CONFIG.h:
1826          @echo Creating \$@ ...          @echo Creating \$@ ...
1827          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1828    FC_NAMEMANGLE.h:
1829            @echo Creating \$@ ...
1830            echo "$FC_NAMEMANGLE" > \$@
1831    
1832    # The normal chain of rules is (  .F - .$FS - .o  )
1833    
1834    %.o : %.F
1835    
1836  # The normal chain of rules is (  .F - .f - .o  )  .F.$FS:
 .F.f:  
1837          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1838  .f.o:  .$FS.o:
1839          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1840  .F90.f90:  .F90.$FS90:
1841          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1842  .f90.o:  .$FS90.o:
1843          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1844  .c.o:  .c.o:
1845          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1846    
1847  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1848  .F.p:  .F.p:
1849          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1850  .p.f:  .p.$FS:
1851          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1852    
1853  #=========================================  #=========================================
# Line 1533  done Line 1874  done
1874    
1875  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1876  echo >> $MAKEFILE  echo >> $MAKEFILE
1877  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1878  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1879  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1880      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1881      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1882  done  done
1883  echo >> $MAKEFILE  echo >> $MAKEFILE
1884  rm -f ad_files  rm -f ad_files
# Line 1550  adtaf: ad_taf_output.f Line 1891  adtaf: ad_taf_output.f
1891  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1892    
1893  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1894          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1895          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1896          -rm -f ad_config.template          -rm -f ad_config.template
1897          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1582  ftltaf: ftl_taf_output.f Line 1923  ftltaf: ftl_taf_output.f
1923  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1924    
1925  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1926          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1927          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1928          -rm -f ftl_config.template          -rm -f ftl_config.template
1929          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1631  for i in $KPPFILES ; do Line 1972  for i in $KPPFILES ; do
1972      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1973          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1974      fi      fi
1975      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
1976  done  done
1977    
1978  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1641  for i in $NOOPTFILES ; do Line 1982  for i in $NOOPTFILES ; do
1982      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1983          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1984      fi      fi
1985      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
1986      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
1987  done  done
1988    
# Line 1655  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1996  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1996  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1997    
1998  # Create special header files  # Create special header files
1999  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2000  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2001      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2002  else  else
2003      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2004      RETVAL=$?      RETVAL=$?
2005      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
2006          rm -f $PACKAGES_DOT_H".tmp"          rm -f $PACKAGES_DOT_H".tmp"
# Line 1669  else Line 2010  else
2010      fi      fi
2011  fi  fi
2012  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2013      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2014  fi  fi
2015    
2016    
2017  #  Write the "state" for future records  #  Write the "state" for future records
2018  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2019      echo -n "" > genmake_state      printf "" > genmake_state
2020      for i in $gm_state ; do      for i in $gm_state ; do
2021          t1="t2=\$$i"          t1="t2=\$$i"
2022          eval $t1          eval $t1

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.79

  ViewVC Help
Powered by ViewVC 1.1.22